import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.Arrays;

public class Check implements Checker {
    public static final int MAX_VAL = 1_000_000_000;

    int[] readArray(int n, InStream is) {
        int[] ar = new int[n];
        for (int i = 0; i < n; ++i) {
            ar[i] = is.nextInt();
        }
        return ar;
    }

    private String check(int[] a, int x, int y) {
        if (x == -1 && y == -1) {
            return null;
        }
        int n = a.length;

        if (x > n) {
            return "x > n";
        } else if (x <= 0) {
            return "x <= 0";
        }

        if (y > n) {
            return "y > n";
        } else if (y <= 0) {
            return "y <= 0";
        }

        for (int i = 0; i < n; ++i) --a[i];
        --x;
        --y;
        if (a[x] == y) {
            return String.format("y = a[x] (y = %d, x = %d)", y + 1, x + 1);
        }

        a[x] = y;
        boolean[] use = new boolean[n];
        int v = 0;
        for (int i = 0; i < n; ++i) {
            if (use[v]) {
                return "Cycle found";
            }
            use[v] = true;
            v = a[v];
        }
        if (v != 0) {
            return "Cycle found";
        }
        return "";
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int xPart = ouf.nextInt(), yPart = ouf.nextInt();
        int xJury = ans.nextInt(), yJury = ans.nextInt();

        int n = inf.nextInt();
        int[] a = readArray(n, inf);
        int[] b = Arrays.copyOf(a, n);

        String jRes = check(a, xJury, yJury);
        if (jRes != null && !jRes.isEmpty()) {
            return new Outcome(Outcome.Type.FAIL, jRes);
        }
        String pRes = check(b, xPart, yPart);
        if (pRes != null && !pRes.isEmpty()) {
            return new Outcome(Outcome.Type.WA, pRes);
        }

        ans.nextLine();
        ans.close();
        ouf.seekEoF();
        ouf.close();
        if (pRes == null && jRes == null) {
            return new Outcome(Outcome.Type.OK, "No solution");
        } else if (pRes != null && jRes != null) {
            return new Outcome(Outcome.Type.OK, "OK. Party answer = " + xPart + " " + yPart);
        } else if (jRes == null) {
            return new Outcome(Outcome.Type.FAIL, "Jury don't have solution, but participant has");
        } else {
            return new Outcome(Outcome.Type.WA, "Jury have solution, but participant doesn't have");
        }
    }
}
