#include <cstdio>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

struct spider
{
	int age, children, ind; 
	spider () {}
	spider(int age, int children, int ind) : age(age), children(children), ind(ind) {} 
};

struct cmp
{
	inline bool operator () (spider a, spider b) 
	{
		pair <int, int> ap, bp;
		ap = make_pair(a.age, a.children);
		bp = make_pair(b.age, b.children);
		return ap < bp;
	}
};

const int N = 2000010;
int parent[N];

int main()
{
	freopen("acromantula.in", "rt", stdin);
	freopen("acromantula.out", "wt", stdout);
	int n;
	scanf("%d", &n);

	vector <spider> inds(n);
	deque <int> child;
	for (int i = 0; i < n; i++)
	{
		int a, c;
		scanf("%d%d", &a, &c);
		inds[i] = spider(a, c, i);
	}
	sort(inds.begin(), inds.end(), cmp());

	fill(parent, parent + n, -1);
	for (int i = 0; i < n; i++)
	{
		while (!child.empty() && inds[i].children)
		{
			if (inds[child.back()].age == inds[i].age)
			{
				break;
			}
			parent[inds[child.back()].ind] = inds[i].ind;
			child.pop_back();
			--inds[i].children;
		}
		child.push_front(i);
	}
	if (child.size() != 1)
	{
		printf("NO");
	}
	else
	{
		printf("YES\n");
		for (int i = 0; i < n; i++)
		{
			printf("%d ", parent[i] + 1);
		}
	}
	return 0;
}