#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

const int MAX = 100;
int cur_test = -1;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(string test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << test << endl;
}

char randc()
{
    return rnd.next('Z' - 'A' + 1) + 'A';
} 

char randc(char l, char r)
{
    return rnd.next(r - l + 1) + l;
}

void gen_rand(int n)
{
    string res = "";
    for (int i = 0; i < n; i++)
        res += randc();
    write_test(res);    
}

void gen_rand1(int n)
{
    string res = "";
    char l = randc();
    char r = randc();
    if (l > r)
        swap(l, r);
    for (int i = 0; i < n; i++)
        res += randc(l, r);
    write_test(res);    
}

void gen_rand2(int n)
{
    string res = "";
    char l = randc();
    if (l == 'Z')
        l--;
    for (int i = 0; i < n; i++)
        res += randc(l, l + 1);
    write_test(res);     
}

void gen_eq(int n)
{
    string res = "";
    char l = randc();
    for (int i = 0; i < n; i++)
        res += l;
    write_test(res);     
}


void gen_rand_sp(int n)
{
    string res = "";
    char l = randc();
    if (l == 'Z')
        l--;
    for (int i = 0; i < n / 2; i++)
        res += l, res += (char)(l + 1);
    if (n < 100 && rnd.next(3) != 0)
        res += (char)(l + 1);
    write_test(res);  
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    write_test("A");
    write_test("AAAA");
    write_test("ZZZ");
    write_test("AZ");
    write_test("QWERTY");
    write_test("AAAABAAAAAAAAAAAAB");
    write_test("ABABBAABABABABB");
    for (int i = 8; i <= 128; i *= 2)
    {
        gen_rand(min(MAX, rnd.next(i / 2) + i / 2 + 1));
        gen_rand1(min(MAX, rnd.next(i / 2) + i / 2 + 1));
        gen_rand2(min(MAX, rnd.next(i / 2) + i / 2 + 1));
        gen_eq(min(MAX, rnd.next(i / 2) + i / 2 + 1));
        gen_rand_sp(min(MAX, rnd.next(i / 2) + i / 2 + 1));
    }
    gen_rand(MAX);
    gen_rand1(MAX);
    gen_rand2(MAX);
    gen_eq(MAX);
    gen_rand_sp(MAX);
    return 0;
}