#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;

int pow10(int x) {
    int ret = 1;
    for (int i = 1; i <= x; ++i) {
        ret *= 10;
    }
    return ret;
}

int cntQ(const string& s) {
    int ret = 0;
    for (int i = 0; i < s.size(); ++i) {
        ret += s[i] == '?';
    }
    return ret;
}

int cntWays(const string& str, bool isRig) {
    if (str.size() != 0 && str[0] == '?' && isRig) {
        return pow10(cntQ(str.substr(1, str.size() - 1))) * 9;
    } else {
        return pow10(cntQ(str));
    }
}

void rSort(vector<int>& a, int pw, int m) {
    for (int i = 0; i < a.size(); ++i) {
        a[i] = (int)(1LL * a[i] * pw % m);
    }
    sort(a.begin(), a.end());
}

int mod;
string str;
int strlength;
bool isRig;
int sz;

void recBrute(int pos, int val, vector<int>& ret) {
    if (pos == strlength) {
        ret[sz++] = val % mod;
        return;
    }
    if (str[pos] == '?') {
        for (int d = (isRig && pos == 0 ? 1 : 0); d < 10; ++d) {
            recBrute(pos + 1, val * 10 + d, ret);
        }
    } else {
        recBrute(pos + 1, val * 10 + (str[pos] - '0'), ret);
    }
}

void brute(const string& s, bool isR, vector<int>& ret) {
    isRig = isR;
    str = s;
    strlength = str.length();
    ret = vector<int>(cntWays(str, isRig));
    sz = 0;
    recBrute(0, 0, ret);
}

int main() {
    freopen("numrecovery.in", "r", stdin);
    freopen("numrecovery.out", "w", stdout);
    string s;
    cin >> s >> mod;
    int n = s.length();
    vector<int> lef, rig;
    brute(s.substr(0, n / 2), true, rig);
    brute(s.substr(n / 2, n), false, lef);
    int pw = pow10((n + 1) / 2);
    sort(lef.begin(), lef.end());
    rSort(rig, pw % mod, mod);

    int mn = (lef[0] + rig[0]) % mod, cr;
    for (int l = 0, r = (int)rig.size() - 2; l < lef.size(); ++l) {
        for (; r >= 0 && lef[l] + rig[r] >= mod; --r);
        cr = (lef[l] + rig[r + 1]) % mod;
        if (cr < mn) {
            mn = cr;
        }
    }
    cout << mn << endl;
    return 0;
}
