import random
random.seed("basic04/robot")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test('LLRL', 2)
        self.print_test('R', 0)

    def generate_min_tests(self):
        self.print_test('L', -1)
        self.print_test('L', -10**5)
        self.print_test('L', 0)
        self.print_test('L', 5)
        self.print_test('R', 1)
        self.print_test('R', 5)
        self.print_test('R', -1)
        self.print_test('LR', -5)
        self.print_test('RL', 5)
        self.print_test('LR', 0)
        self.print_test('RL', 0)

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn):
        s = ''
        for i in range(maxn):
            s += 'L' if random.randint(1, 2) == 1 else 'R'
        self.print_test(s, random.randint(-10**5, 10**5))

    def generate_random_one_extra_letter_test(self, maxn):
        if random.randint(1, 2) == 1:
            s = 'L' * (maxn - 1)
            index = random.randint(0, len(s))
            s = s[:index] + 'R' + s[index:]
        else:
            s = 'R' * (maxn - 1)
            index = random.randint(0, len(s))
            s = s[:index] + 'L' + s[index:]
        self.print_test(s, random.randint(-10**5, 10**5))

    def generate_one_letter_test(self, maxn):
        if random.randint(1, 2) == 1:
            s = 'L' * maxn
        else:
            s = 'R' * maxn
        c = s[0]
        if c == 'L':
            self.print_test(s, random.randint(max(-10**5, -maxn - 10), -maxn))
            self.print_test(s, random.randint(-maxn, -maxn + 10))
            self.print_test(s, random.randint(0, 10))
            self.print_test(s, 0)
        else:
            self.print_test(s, random.randint(maxn, min(10**5, maxn + 10)))
            self.print_test(s, random.randint(maxn - 10, maxn))
            self.print_test(s, random.randint(-10, 0))
            self.print_test(s, 0)

    def generate_max_tests(self, maxn):
        self.print_test('L' * maxn, -maxn)
        self.print_test('L' * maxn, -maxn + 1)        
        self.print_test('R' * maxn, maxn)
        self.print_test('R' * maxn, maxn - 1)

    def print_test(self, turns, x):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(turns, file=test_file)
        print(x, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 50, 100, 500, 1000, 10**4, 10**5]
        for n in ns:
            self.generate_random_test(n)
            self.generate_random_one_extra_letter_test(n)
            self.generate_one_letter_test(n)
        self.generate_max_tests(10**5)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
